// global parameters are here

#ifndef __SHARED_FX
#define __SHARED_FX

#include "defines.fx"


// --------------------------------------------------------------------------
// time

shared float	fTime;

// --------------------------------------------------------------------------
// camera

shared float4x4	mView;
shared float4x4	mProjection;
shared float4x4	mViewProj;
shared float3		vEye;

// --------------------------------------------------------------------------
// hacked in light

shared float3	vLightDir = normalize( float3(-0.2,-1,0.4) );
shared float3	vLightAmbient = 0.4;
shared float3	vLightDiffuse = 0.7;
static float	fShadow = 0.6;

// --------------------------------------------------------------------------
//  global cull/blend params

// cull mode: CW=2 (should be default), CCW=3 (for reflected, etc.)
shared int		iCull = 2;


// --------------------------------------------------------------------------
//  others


shared float4x4	mViewTexProj;
shared float4x4 mShadowProj1;
shared float4x4 mShadowProj2;


const static float4x4 mIdentity = float4x4(
	1,0,0,0,
	0,1,0,0,
	0,0,1,0,
	0,0,0,1 );
const static float4x4 mSphereMap = float4x4(
	0.4,0,  0, 0,
	0, -0.4,0, 0,
	0,  0.0,0, 0,
	0.5,0.5,0, 0 );


#endif
